<?php
namespace Teknisa\PLA\Modules\Parametros\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\Report\ReportService;

class Ger96000CentralReport extends \Zeedhi\Framework\Controller\Report{
   
    protected $reportService;
    protected $qr2Strategy;
    protected $util;
    protected $environment;
    protected $nrlista;
    protected $birtStrategy;

    public function __construct($reportService, $qr2Strategy, $util, $environment , $birtStrategy) {
    	$this->reportService = $reportService;
        $this->qr2Strategy = $qr2Strategy;
        $this->util = $util;
        $this->environment = $environment;
    	$this->birtStrategy = $birtStrategy;
    }
    
    protected $reportMapping = array (
        'GER96000' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'LFILIAL' => 'P_CDFILIAL',
                        'TFILIAL' => 'P_TCDFILIAL',
                        'NRORG'   => 'P_NRORG'
                    )
            )
    );
    
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        if($row['TFILIAL'] == null  ){
            $row['TFILIAL'] = 'X';
        }
        $row["NRORG"] = $this->environment->getNrOrg();
        $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
    }
}